function H=abs2h(P,A,B)

% H=abs2h(P,A,B) : solves P-A P A' = B H + H' B'
% with H such that HB is Hermitian.
%
% B needs to be full column rank, A a stable matrix,
% and the above equation needs to have a solution,
% i.e. rank[P-A*P*A' B; B' zeros] = 2*rank(B).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% earier version had P,A,B ordered as A,B,P
% which could be a problem if called by an earlier generation routine

D=P-A*P*A';
[n,m]=size(B);
%if(rank([D B; B' zeros(m,m)]) ~= 2*rank(B)),
%disp('There is no solution')
%return
%end

if(det(B'*B)==0),
disp('B has no full column rank'),
return
end

HB=lyap(B'*B,-B'*D*B);
H=(B'*B)\(B'*D-HB'*B');