function dlambda=dlam(t,lambda)
% --- needed only in meP.m (side routine)
%
% function dlambda=dlam(t,lambda)
% dlambda is a certain gradient that is needed in meP.m
% and is used when calling ode-solver to trace a homotopy
% match 'constraints'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global matU vecr

lam=lambda(:);
v=matU*lam;
V=vec2matrix(v);
X=inv(V);
x=mat2vec(X);

r=matU'*x;
direction=r-vecr;

[nU,mU]=size(matU); % nU = n^2 and mU = dim(null space of Sigma's) + 1
H=zeros(mU,mU);
for k=1:mU, 
    Uk=vec2matrix(matU(:,k));
    for ell=k:mU,
            Uell=vec2matrix(matU(:,ell));
      
        H(k,ell)=trace(Uk*X*Uell*X);
        H(ell,k)=H(k,ell);
    end
end

dlambda=inv(H)*direction; dlambda=real(dlambda);