function [num,den]=hankelbased(h)
% [num,den]=hankelbased(h) determines a possibly unstable model
% for an impulse response h, by truncating the corresponding Hankel matrix
% at a svd-break point

h=h(:);
n=length(h); n=2*floor((n-1)/2)+1;
H=hankel(h(1:(n+1)/2),h((n+1)/2:n)'); sizeH=(n+1)/2;
svdH=svd(H);
svdratios=svdH(2:sizeH)./svdH(1:(sizeH-1));
[minratio,r]=min(svdratios);

den=inv(H(1:r,1:r))*H(1:r,r+1); den=[-den; 1]; den=flipud(den);
num=conv(den,h); num=num(1:r+1);