function plotGamma(omega,spectrum)

% plotGamma(omega,spectrum) : magnitude plots of multivariable spectra
%
% omega    : frequency range [omega(1) omega(2) ... ]
% spectrum : [F(1) F(2) ... ] where F(i) is the value of a matricial
%            spectral density at omega(i)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[m,nm]=size(spectrum); n=nm/m;

[m,nm]=size(spectrum); maxvalue=max(max(spectrum));
for i=1:m,
    for k=i:m,
    subplot(m,m,k+(i-1)*m), 
    sp=spectrum(i,k:m:nm);
    plot(omega,abs(sp)), axis([0 pi 0 maxvalue]);
    end
end