function plotspec(omega,spectrum)

% plotspec(omega,spectrum) : log-plots of multivariable spectra
%
% omega    : frequency range [omega(1) omega(2) ... ]
% spectrum : [F(1) F(2) ... ] where F(i) is the value of a matricial
%            spectral density at omega(i)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[m,nm]=size(spectrum); %n=nm/m;

for i=1:m,
    for k=i:m,
    subplot(m,m,k+(i-1)*m), 
    sp=spectrum(i,k:m:nm);
    %plotyy(omega,20*log10(abs(sp)),omega,round(1e5*angle(sp))*1e-5*160/pi)
    plot(omega,20*log10(abs(sp)))
    end
end
    