function [macheck,val,fr]=MAcheck(T,m)
% function [macheck,val,fr]=MAcheck(T,m)
%
% Given a Toeplitz matrix T
% it constructs the quasi-polynomial formed out of the coefficients of T
% (possibly 2*m+1 of them if m is given, otherwise includes all coeff of first row)
% and then checks whether the quasi-polynomial takes positive values on the
% circle. A plot of those values is also shown.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

narg=nargin; if narg<2, m=length(T)-1; end

%figure(10),
M=10000; fr=0:M-1; fr=fr*2*pi/M;
coefzerosfeoc=[T(1,1:m+1) zeros(1,M-2*m-1) fliplr(T(2:m+1,1)')];
val=real(fft(coefzerosfeoc));
%plot(fr,val,'b-',fr,val<0,'r--');
macheck='MA(m) is valid'; if max(val<0), macheck='MA(m) is not valid'; end