function Rprime=blw(S,R)

% determines a Toeplitz matrix D that satisfies
% tr((Rinv S Rinv - Rinv D Rinv)T)=0
% for all Toeplitz T.
%
% see Burg-Luenberger-Wenger

n=length(S); Rinv=inv(R); Q=cell(n,1); Eye=eye(n,n);
for i=1:n,
    Q{i,1}=toeplitz(Eye(i,:));
end

A=[]; 
for i=1:n,
    for j=1:n,
        A(i,j)=trace(Rinv*cell2mat(Q(i,1))*Rinv*cell2mat(Q(j,1))); A(j,i)=A(i,j);
    end,
end

b=[];
for i=1:n,
    b=[b; trace(Rinv*S*Rinv*cell2mat(Q(i,1)))];
end

d=A\b;
Rprime=toeplitz(d);