% simulates an MA process with the parameters in Stoica-Du-Li-Georgiou
% computes the 4 by 4 estimated covariance of a MA-process
% and approximates the power spectrum

N=103; m=4;
MAcoef=[1 -2.3359 2.2770 -0.9124];
sys=filt(MAcoef,1);
u=randn(1,N); y=lsim(sys,u,[0:N-1]); [Rh,A,B,Rf,Rb]=toep_sample_average(y,m);
%y=y'; yvec=[]; for k=1:m, yvec=[yvec; y(m+k-1:N-m+k-1)]; end, R=yvec*yvec'/(N-2*m);
[traceQQh,Tval,Qval,Qhval]=trapprox(R)

rs=conv(MAcoef,fliplr(MAcoef)); Rperfect=toeplitz(rs(m:2*m-1));

[tsignal,tnoise]=MAdecomp(R,m-1);

disp('estimated R'), R
disp('approximated R=Tval'), Tval
disp('their distance '), trqqh(R,Tval)/m
disp('distance between perfect and estimated'), trqqh(Rperfect,R)/m

disp('approximated R=tnoise a-la Stoica_etc'), tnoise
disp('distance between Rperfect and tnoise'), trqqh(Rperfect,tnoise)/m

M=2048;
fr=0:M-1; fr=fr*2*pi/M;
rTval=Tval(1,:); rTval=[fliplr(rTval(2:length(rTval))) rTval];
rtnoise=tnoise(1,:); rtnoise=[fliplr(rtnoise(2:length(rtnoise))) rtnoise];
plot(fr,log(abs(fft(rs,M))),fr,log(abs(fft(rTval,M))),fr,log(abs(fft(rtnoise,M))));
legend('ideal','closest','one-sided')