function [dist, nf, R, trks]=distML(Rh,R)
% [dist,nf,R_normalized] =distML(R)
%
% R is normalized so that trace Rn^(-1)Rh = n
% the normalization factor is nf and Rn := R_normalized = nf*R
%
% dist = norm(vector of k-traces of Rn^(-1)(Rn-Rh)Rn^(-1)) * norm(Rh)
%
% the last normalization is in order to compensate for the fact that the
% signifance of proximity of the k-traces to zero, is affected by the size
% of the R's

nf=trace(inv(R)*Rh)/length(R); R=nf*R;

M=inv(R)*(R-Rh)*inv(R);
n=length(M);
trks=[];
for i=0:n-1,
    trks=[trks sum(diag(M,i))];
end

dist=norm(trks)*norm(Rh);