% simulates an MA process with the parameters in Stoica-Du-Li-Georgiou
% computes the 4 by 4 estimated covariance
% approximates the spectrum

N=103; m=3;
MAcoef=[1 1 1];
sys=filt(MAcoef,1);
u=randn(1,N); y=lsim(sys,u,[0:N-1]); y=y';
yvec=[];mm=m+2;
for k=1:mm, yvec=[yvec; y(m+k-1:N-mm+k-1)]; end
R=yvec*yvec'/(N-2*m);
[traceQQh,Tt,Qt,Qht]=trapprox(Rh5);
[traceQQhma,Tval,Qval,Qhval]=MAapprox(Rh5,2);
%[Tma,Qma,Qhma]=MA_approx(R,2);
[tsignal,tnoise]=MA_decomposition(R,m-1);

rs=conv(MAcoef,fliplr(MAcoef)); Rperfect=toeplitz(rs(m:2*m-1));

M=10000;
fr=0:M-1; fr=fr*2*pi/M;
rTma=Tma(1,:); rTma=[fliplr(rTma(2:length(rTma))) rTma];
rtnoise=tnoise(1,:); rtnoise=[fliplr(rtnoise(2:length(rtnoise))) rtnoise];
plot(fr,log(abs(fft(rs,M))),fr,log(abs(fft(rTma,M))));
legend('ideal','closest')

rTt=Tt(1,1:3); rTt=[fliplr(rTt(2:length(rTt))) rTt];
figure(2), plot(fr,log(abs(fft(rTt,M)))),
figure(3), plot(fr,real(fft(rTt,M))),
figure(1), hold on, 