% simulates an MA process
% computes the sample covariance

N=15; m=3; n=5; % MA of order m, R is n by n, N is the length of the record.

MAcoef=[1 1 1 1]; sys=filt(MAcoef,1);  rideal=conv(MAcoef,fliplr(MAcoef));
Rideal=toeplitz(rideal(m+1:2*m+1));
u=randn(1,N); y=lsim(sys,u,[0:N-1]); y=y';

R=toep_sample_average(y,n)

%mextra=1;
[tr,   Tt,Qt,Qht]=trapprox(R);
mextra=2;
[trma, Tma,Qma,Qhma]=MAapprox(R,m+mextra);
[tq,tma]=MAdecomp(R,m+mextra);

figure(1), hold off,
[macheck,valTma,fr]=MAcheck(Tma,m+mextra); macheck, hold on, pause(1)
[macheck,valtma]=MAcheck(tma,m+mextra); macheck, pause(1)
[macheck,valideal]=MAcheck(Rideal);

figure(1),
semilogy(fr,valideal,fr,valTma,fr,valtma), legend('ideal','MAapprox','MAdecomp')

figure(100),
subplot(2,2,1), imagesc(R),
subplot(2,2,2), imagesc(Rideal),
subplot(2,2,3), imagesc(Tma),
subplot(2,2,4), imagesc(tma),


Rh=rand(2,2); Rh=Rh*Rh';
[trQ,Q,R]=toepQ(Rh);
[trQm,Qm,Rm,Cm]=toepM(Rh);
[trQQh,Qq,Rq,Qhq]=toepQQh(Rh);
[trmm,Qmm,Rmm,Cmm,Qhmm,Chmm,Mmm,Mhmm]=toepMMh(Rh); trQ, trQm, trQQh, trmm


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

N=19; m=3; n=10; % MA of order m, R is n by n, N is the length of the record.

MAcoef=[1 1 1 1]; sys=filt(MAcoef,1);  rideal=conv(MAcoef,fliplr(MAcoef)); Rideal=toeplitz([rideal(m+1:2*m+1) zeros(1,n-m-1)]);
u=randn(1,N); y=lsim(sys,u,[0:N-1]); y=y';
yvec=[]; for k=1:n, yvec=[yvec; y(k:N+k-n)]; end,
R=yvec*yvec'/n;
Rr=flipud(fliplr(R)); Rf=R; R=.5*(R+Rr);
Rh=R;
R0=equalT(Rh);
[tr,Q,Rq]=toepQ(Rh);
[tr,Q,Rqh,Qh]=toepQQh(Rh);
[tr,Q,Rm]=toepM(Rh);
[tr,Q,Rmh,Qh]=toepMMh(Rh);

dds=[distML(Rh,R0); %distML(Rh,Rq);
    distML(Rh,Rqh); distML(Rh,Rm); distML(Rh,Rmh)];
