function [traceQQh,Tval,Qval,Qhval]=scdecomp(Th,A,B)
% [trace(Q+Qh), T, Q, Qh]=scapprox(Th,A,B)
%
%  T+Q=Th  (where T>0, T-ATA'=BH+H'B', Q>0 and tr(Q) is minimal)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n1=length(Th); [n,m]=size(B);
%kk=1:n1; tstructure=toeplitz([kk]);
Neps=1e-9;

setlmis([])
T=lmivar(1,[n1,1]);
Q=lmivar(1,[n1,1]);
%Qh=lmivar(1,[n1,1]);
H=lmivar(2,[m,n]);

lmiterm([1 1 1 T],1,1);
lmiterm([-1 1 1 0],Th+eye(n1,n1)*Neps);
lmiterm([1 1 1 Q],1,1);
%lmiterm([-1 1 1 Qh],1,1);
%
lmiterm([2 1 1 0],Th-eye(n1,n1)*Neps)
lmiterm([-2 1 1 T],1,1);
%lmiterm([2 1 1 Qh],1,1);
lmiterm([-2 1 1 Q],1,1);
%
lmiterm([-3 1 1 Q],1,1);
lmiterm([3 1 1 0],0);
%
%lmiterm([-4 1 1 Qh],1,1);
%lmiterm([4 1 1 0],0);
%
lmiterm([-4 1 1 T],1,1);
lmiterm([4 1 1 0],0);
%
lmiterm([5 1 1 T],1,1);
lmiterm([-5 1 1 T],A,A');
lmiterm([-5 1 1 0],eye(n1,n1)*Neps)
lmiterm([-5 1 1 H],B,1,'s');
%lmiterm([-6 1 1 -H],1,B');
%
lmiterm([-6 1 1 T],1,1);
lmiterm([6 1 1 T],A,A');
lmiterm([-6 1 1 0],eye(n1,n1)*Neps)
lmiterm([6 1 1 H],B,1,'s');
%lmiterm([7 1 1 -H],1,B');
%
lmisys=getlmis;

weight=eye(n1,n1);zerow=zeros(n1,n1);zeroH=zeros(m,n);
c=mat2dec(lmisys,zerow,weight,zeroH);
options=[1e-13,0,0,0,1];
[copt,xopt]=mincx(lmisys,c,options);

Tval=dec2mat(lmisys,xopt,T);
Qval=dec2mat(lmisys,xopt,Q);
%Qhval=dec2mat(lmisys,xopt,Qh);
traceQQh=trace(Qval);

% Written by T.T. Georgiou (November 2006)
