function [tr,Qval,Rval]=toepQ(Rh)
% [trace(Q), Q, R]=toepQ(Rh)  :  Rh=R+Q, R,Q>0, R Toeplitz, and trace(Q)=minimal
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n1=length(Rh); kk=1:n1; Neps=1e-9; tstructure=toeplitz([kk]); 

setlmis([])
R=lmivar(3,tstructure);
Q=lmivar(1,[n1,1]);
%
lmiterm([1 1 1 R],1,1)
lmiterm([1 1 1 Q],1,1);
lmiterm([-1 1 1 0],Rh+eye(n1,n1)*Neps);
%
lmiterm([2 1 1 0],Rh-eye(n1,n1)*Neps)
lmiterm([-2 1 1 R],1,1);
lmiterm([-2 1 1 Q],1,1);
%
lmiterm([-3 1 1 Q],1,1);
lmiterm([3 1 1 0],0);
%
lmiterm([-4 1 1 R],1,1);
lmiterm([4 1 1 0],0);
lmisys=getlmis;

weight=eye(n1,n1);
c=mat2dec(lmisys,0,weight);
options=[1e-13,0,0,0,1];
[copt,xopt]=mincx(lmisys,c,options);

Qval=dec2mat(lmisys,xopt,Q);
Rval=dec2mat(lmisys,xopt,R);
tr=trace(Qval);
% Written by T.T. Georgiou