function [tr,Qval,Rval, Qhval]=toepQQh(Rh)
% [trace(Q+Qh), Q, R, Qh]=toepQQh(Rh)  :  Rh+Qh=R+Q, R,Q,Qh>0, R Toeplitz, and trace(Q+Qh)=minimal
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n1=length(Rh); kk=1:n1; Neps=1e-9; tstructure=toeplitz([kk]); 

setlmis([])
R=lmivar(3,tstructure);
Q=lmivar(1,[n1,1]);
Qh=lmivar(1,[n1,1]);
%
lmiterm([1 1 1 R],1,1)
lmiterm([1 1 1 Q],1,1);
lmiterm([-1 1 1 0],Rh+eye(n1,n1)*Neps);
lmiterm([-1 1 1 Qh],1,1);
%
lmiterm([2 1 1 0],Rh-eye(n1,n1)*Neps)
lmiterm([-2 1 1 R],1,1);
lmiterm([-2 1 1 Q],1,1);
lmiterm([2 1 1 Qh],1,1);
%
lmiterm([-3 1 1 Q],1,1);
lmiterm([3 1 1 0],0);
%
lmiterm([-4 1 1 R],1,1);
lmiterm([4 1 1 0],0);
%
lmiterm([-5 1 1 Qh],1,1);
lmiterm([5 1 1 0],0);
%
lmisys=getlmis;

weight=eye(n1,n1);
c=mat2dec(lmisys,0,weight,weight);
options=[1e-13,0,0,0,1];
[copt,xopt]=mincx(lmisys,c,options);

Qval=dec2mat(lmisys,xopt,Q);
Qhval=dec2mat(lmisys,xopt,Qh);
Rval=dec2mat(lmisys,xopt,R);
tr=trace(Qval+Qhval);
% Written by T.T. Georgiou