function [traceQQh,Tval,Qval,Qhval]=trapprox(Th)
% [trace(Q+Qh), T, Q, Qh]=trapprox(Th)  :  T+Q=Th+Qh  (where T>0 and Toeplitz, Q,Qh>0 and tr(Q+Qh) is minimal)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n1=length(Th); kk=1:n1; tstructure=toeplitz([kk]); Neps=1e-9;

setlmis([])
T=lmivar(3,tstructure);
Q=lmivar(1,[n1,1]);
Qh=lmivar(1,[n1,1]);
lmiterm([1 1 1 T],1,1);
lmiterm([-1 1 1 0],Th+eye(n1,n1)*Neps);
lmiterm([1 1 1 Q],1,1);
lmiterm([-1 1 1 Qh],1,1);
%
lmiterm([2 1 1 0],Th-eye(n1,n1)*Neps)
lmiterm([-2 1 1 T],1,1);
lmiterm([2 1 1 Qh],1,1);
lmiterm([-2 1 1 Q],1,1);
%
lmiterm([-3 1 1 Q],1,1);
lmiterm([3 1 1 0],0);
%
lmiterm([-4 1 1 Qh],1,1);
lmiterm([4 1 1 0],0);
%
lmiterm([-5 1 1 T],1,1);
lmiterm([5 1 1 0],0);
lmisys=getlmis;

weight=eye(n1,n1);zerow=zeros(n1,n1);
c=mat2dec(lmisys,zerow,weight,weight);
options=[1e-13,0,0,0,1];
[copt,xopt]=mincx(lmisys,c,options);

Tval=dec2mat(lmisys,xopt,T);
Qval=dec2mat(lmisys,xopt,Q);
Qhval=dec2mat(lmisys,xopt,Qh);
traceQQh=trace(Qval+Qhval);

% Written by T.T. Georgiou (November 2006)
