function [spec,omega]=MA_spec(Tn,N)

% [spec,omega]=MAspec(T_n,N) : spectrum of a MA-process with covariance T_n
%
% spec : the power spectrum of a moving average process corresponding to
%        the Toeplitz covariance matrix T_n evaluated at N equispaced
%        points via fft
%
% omega: linspace(0,2*pi,N)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
qv=Tn(:,1); qh=Tn(1,2:length(Tn)); q=[fliplr(conj(qv')) qh];
spec=abs(fft(q,N)); omega=linspace(0,2*pi,N);