function drift=spectraldrift(u,widthwindow,skipk,n,lambda)

% drift = spectraldrift(u,widthwindow,skipk,ARorder)
%
% analyzes windows of data, WIDTHWINDOW wide, skipping SKIPK samples
% until the next one, and computing geodesic distances between corresponding
% power spectral densities.
%
% Use:
% drift=spectraldrift(u,widthwindow,skipk,n,lambda)
%
% (n,lambda): data used for spectral analysis,
%             default values n=15, lambda=0
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if narging<5, n=15; lambda=0; end

f=spectrum_generic(u(1:widthwindow));
    flast=f;
    
    kk=length(1+skipk:skipk:length(u)-widthwindow-1);
    drift=zeros(1,kk);
    
    i=1;
for k=1+skipk:skipk:length(u)-widthwindow-1,
    f=spectrum_generic(u(k:k+widthwindow-1),n,lambda);
    drift(i)=spectral_distance(f,flast);
    flast=f;i=i+1;
end

