function [f,omega] = spectrum_generic(u,n,lambda,omega)

% [f,omega] = spectrum_generic(u,n,lambda,omega) spectral density of real uusing ME.m 
%
% n = number of poles at locations in lambda
% e.g., n=[3 2 2]; lambda=[0 .7*exp(1i*pi/2) .7*exp(1i*pi/1.2)];

% set N, STARTFREQ and ENDFREQ for
% specifying a generic frequency range of interest

if nargin<4,
    startfreq=0; endfreq=pi; N=500;
    omega=linspace(startfreq,endfreq,N);
end

if nargin<3,
    n=[10 2]; lambda=[0 .5*exp(1i*pi/2)];
    disp('default choice n=[10 2], lambda=[0 .5*exp(1i*pi/2)], i.e., 10 poles at 0 and some complex ones for a bandpass weight'),
end

[A,b]=rjordan2(n,lambda);

u=u(:)';
P=dlsim_real(A,b,u);
f = me(P,A,b,omega);